package eu.maiora.model

import eu.maiora.db.*
import org.jetbrains.exposed.sql.or

class ArticoliCrossQRicambiRepositoryImpl : ArticoliCrossQRicambiRepository {
    override suspend fun articoloByCodArt(codice: String): List<ArticoliCrossQRicambi> = suspendTransaction {
        // Cerca un articolo dalla tabella ArticoliCrossQRicambiTable
        ArticoliCrossQRicambiDAO.find { (ArticoliCrossQRicambiTable.codiceArticolo eq codice) or (ArticoliCrossQRicambiTable.codiceCross eq codice)  }
            .toList() // Restituisce un singolo risultato o null se non trovato
            .map { articoliCrossQRicambiDaoToModel(it) } // Converte il DAO in un oggetto ArticoliCrossQRicambi

    }
    /*override suspend fun articoloByCodCross(codice: String): ArticoliCrossQRicambi? = suspendTransaction {
        // Cerca un articolo dalla tabella ArticoliCrossQRicambiTable
        ArticoliCrossQRicambiDAO.find { ArticoliCrossQRicambiTable.codiceCross eq codice }
            .singleOrNull() // Restituisce un singolo risultato o null se non trovato
            ?.let { articoliCrossQRicambiDaoToModel(it) } // Converte il DAO in un oggetto ArticoliCrossQRicambi

    }*/
}