package eu.maiora.model

import eu.maiora.db.*
import org.jetbrains.exposed.sql.or

class ViewClientiAgentiRepositoryImpl : ViewClientiAgentiRepository {
    override suspend fun clienteByAgente(username: String): ViewClientiAgenti? = suspendTransaction {
        // Cerca un cliente dalla tabella ViewClientiAgenti
        ViewClientiAgentiDAO.find { ViewClientiAgentiTable.username eq username }
            .singleOrNull() // Restituisce un singolo risultato o null se non trovato
            ?.let { viewClientiAgentiDaoToModel(it) } // Converte il DAO in un oggetto ViewClientiAgenti

    }
}