package eu.maiora.model

import eu.maiora.db.*
import eu.maiora.loadConfig
import org.jetbrains.exposed.sql.LongColumnType

class ViewEcommercePrezSconDispRepositoryImpl : ViewEcommercePrezSconDispRepository {
    override suspend fun disponibilitaByIdArtIdClie(idCliente: Long, idArticolo : Long): List<ViewEcommercePrezSconDisp>? = suspendTransaction {
        // Cerca le disponibilit e i prezzi dato articolo e cliente dalla table function ViewEcommercePrezSconDispTable
        val properties = loadConfig()

        val result = exec("SELECT * FROM dbo.Get_Prez_Scon_Disp(?, ?)", listOf(
            LongColumnType() to idCliente,
            LongColumnType() to idArticolo
        )) { rs ->
            val list = mutableListOf<ViewEcommercePrezSconDisp>()
            while (rs.next()) {
                val element : ViewEcommercePrezSconDisp
                if(idCliente == properties.getProperty("qricambi.id").toLong()){
                    element = ViewEcommercePrezSconDisp(
                        id = rs.getLong("id"),
                        idCliente = rs.getLong("id_cliente"),
                        idArticolo = rs.getLong("id_articolo"),
                        idMagazzino = -1,
                        magazzino = "",
                        valoreCarcassa = rs.getDouble("valore_carcassa"),
                        prezzo = 0.0,
                        sconto = 0.0,
                        sconto1 = 0.0,
                        sconto2 = 0.0,
                        sconto3 = 0.0,
                        netto = 0.0,
                        numeroPezzi = rs.getInt("numero_pezzi")
                    )
                }
                else {
                    element = ViewEcommercePrezSconDisp(
                        id = rs.getLong("id"),
                        idCliente = rs.getLong("id_cliente"),
                        idArticolo = rs.getLong("id_articolo"),
                        idMagazzino = rs.getLong("id_magazzino"),
                        magazzino = rs.getString("magazzino"),
                        valoreCarcassa = rs.getDouble("valore_carcassa"),
                        prezzo = rs.getDouble("prezzo"),
                        sconto = rs.getDouble("sconto"),
                        sconto1 = rs.getDouble("sconto_1"),
                        sconto2 = rs.getDouble("sconto_2"),
                        sconto3 = rs.getDouble("sconto_3"),
                        netto = rs.getDouble("netto"),
                        numeroPezzi = rs.getInt("numero_pezzi")
                    )
                }


                list.add(element)

            }
            list
        }

        result?.ifEmpty { emptyList() }

    }
}