package eu.maiora.model

import eu.maiora.db.*
import org.jetbrains.exposed.sql.LongColumnType

class ViewEcommerceValoreUsatoRepositoryImpl : ViewEcommerceValoreUsatoRepository {
    override suspend fun getValoreByIdArtIdClie(idCliente: Long, idArticolo : Long): List<ViewEcommerceValoreUsato>? = suspendTransaction {
        // Cerca il valore della carcassa dalla table function ViewEcommerceValoreUsatoTable

        val result = exec("SELECT * FROM dbo.Get_Valore_usato(?, ?)", listOf(
            LongColumnType() to idCliente,
            LongColumnType() to idArticolo
        )) { rs ->
            val list = mutableListOf<ViewEcommerceValoreUsato>()
            while (rs.next()) {
                val element : ViewEcommerceValoreUsato
                    element = ViewEcommerceValoreUsato(
                        id = rs.getLong("id"),
                        idCliente = rs.getLong("id_cliente"),
                        idArticolo = rs.getLong("id_articolo"),
                        valoreUsato = rs.getDouble("valore_usato")
                    )
                list.add(element)

            }
            list
        }

        result?.ifEmpty { emptyList() }

    }
}