package eu.maiora.plugins

import eu.maiora.model.*
import eu.maiora.routes.auth
import eu.maiora.routes.disponibilitaArticoli
import io.ktor.server.application.*
import io.ktor.server.response.*
import io.ktor.server.routing.*

fun Application.configureRouting() {
    routing {
        get("/") {
            call.respondText("Hello World!")
        }

        auth(AccountsRepositoryImpl())
        disponibilitaArticoli(ArticoliCrossQRicambiRepositoryImpl(),
                                ViewEcommerceArticoliRepositoryImpl(),
                                ViewEcommercePrezSconDispRepositoryImpl(),
                                ViewClientiAgentiRepositoryImpl(),
                                ViewEcommerceValoreUsatoRepositoryImpl())
    }
}
